#lang racket
(require "const.rkt"
         "msg.rkt")

(provide run-player)

(define (run-player get put)
  (define (play x y)
    (match (random 4)
      [0 (try-move (add1 x) y x y)]
      [1 (try-move (sub1 x) y x y)]
      [2 (try-move x (add1 y) x y)]
      [3 (try-move x (sub1 y) x y)]))
  
  (define (try-move x y old-x old-y)
    (if (and (< -1 x HSIZE) (< -1 y VSIZE))
        (begin
          (put (move-request x y))
          (match (get)
            [(quit) (void)]           
            [(move)
             (play x y)]
            [(bump)
             (play old-x old-y)]
            [(pass)
             (put (run-contest))
             (play old-x old-y)]
            [(steal)
             (put (run-contest))
             (play old-x old-y)]))
        (play old-x old-y)))

  ;; Start the player:
  (put (state-request))
  (match (get)
    [(state x y ball?)
     (play x y)]))

(define (run-contest)
  (let loop ([c1 0] [c2 0])
    (cond
      [(= c1 10000) #t]
      [(= c2 10000) #f]
      [(positive? (random 2)) (loop (add1 c1) c2)]
      [else (loop c1 (add1 c2))])))
